//+------------------------------------------------------------------+
//| ADX Crossing.mq4 
//+------------------------------------------------------------------+
#property  copyright "Author - Amir, modified by akadex"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

//---- input parameters
extern int    ADXbars         = 14;
extern int    STDRgresperiod  = 0;
extern int    STDRgreslength  = 56;
extern double STDRgreswidth   = 1.618;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";
//---- buffers
double val1[],val2[],cross[];
double b4plusdi,nowplusdi,b4minusdi,nowminusdi,m50,m120,one,two,trend=0,c,b,a,starttime,grad,hi,lo;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   SetIndexBuffer(0,val1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,val2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108);
   SetIndexBuffer(2,cross);
//----
   return(0);
  }
  int deinit()
  { ObjectsDeleteAll(0, OBJ_STDDEVCHANNEL); ObjectsDeleteAll(0, OBJ_TRENDBYANGLE); ObjectsDeleteAll(0, OBJ_TREND); Comment(""); return(0);}
//+------------------------------------------------------------------+
//| AltrTrend_Signal_v2_2                                            |
//+------------------------------------------------------------------+
int start()
  {   
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
	
	for(int i=limit; i>=0; i--)
	{
   starttime=iTime(Symbol(),STDRgresperiod,STDRgreslength);
   ObjectCreate("regression channel",OBJ_STDDEVCHANNEL,0,starttime,Bid,Time[0],Ask);
   ObjectSet("regression channel",OBJPROP_TIME1,starttime);
   ObjectSet("regression channel",OBJPROP_TIME2,Time[0]);
   ObjectSet("regression channel",OBJPROP_DEVIATION,STDRgreswidth);
   ObjectSet("regression channel",OBJPROP_RAY,true);
   one=ObjectGet("regression channel", OBJPROP_PRICE1);
   two=ObjectGet("regression channel", OBJPROP_PRICE2);
   string trendText="";
   if (one<two) {trend = 1;  b=two-one;}
   if (one>two) {trend =-1;  b=one-two;}
   if (trend == 1) { trendText = "up";   }
   if (trend ==-1) { trendText = "down"; }

  ObjectCreate("grad channel",OBJ_TRENDBYANGLE,0,0,0);
  ObjectSet("grad channel",OBJPROP_WIDTH,3);
  ObjectSet("grad channel",OBJPROP_TIME1,starttime);
  ObjectSet("grad channel",OBJPROP_TIME2,Time[0]);
  ObjectSet("grad channel",OBJPROP_PRICE1,one);
  ObjectSet("grad channel",OBJPROP_PRICE2,two); 
  grad=ObjectGet("grad channel", OBJPROP_ANGLE);
      
   hi=iHigh(NULL,PERIOD_D1,1);
   lo=iLow(NULL,PERIOD_D1,1);
      ObjectCreate("HDayBorder", OBJ_TREND, 0, 0,0, 0,0);
    ObjectSet("HDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STDRgreslength], TIME_DATE)+" 00:00"));
    ObjectSet("HDayBorder", OBJPROP_TIME2, Time[0]);
    ObjectSet("HDayBorder", OBJPROP_PRICE1, hi);
    ObjectSet("HDayBorder", OBJPROP_PRICE2, hi);
    ObjectSet("HDayBorder", OBJPROP_COLOR, Blue);
    ObjectSet("HDayBorder", OBJPROP_STYLE, STYLE_DASH);
        
      ObjectCreate("LDayBorder", OBJ_TREND, 0, 0,0, 0,0);
    ObjectSet("LDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STDRgreslength], TIME_DATE)+" 00:00"));
    ObjectSet("LDayBorder", OBJPROP_TIME2, Time[0]);
    ObjectSet("LDayBorder", OBJPROP_PRICE1, lo);
    ObjectSet("LDayBorder", OBJPROP_PRICE2, lo);
    ObjectSet("LDayBorder", OBJPROP_COLOR, Red);
    ObjectSet("LDayBorder", OBJPROP_STYLE, STYLE_DASH);
   
    Comment ("\nChannel Angle = ",grad,"\nTrend = ",trendText,"\nYesterdays High Price = ",hi,"\nYesterdays Low Price = ",lo);

	 double adxplus  = iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI, i);
    double adxminus = iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,i);
      
        cross[i] = cross[i+1];
           if (adxplus > adxminus) cross[i] = 1;
           if (adxplus < adxminus) cross[i] =-1;

           //
           //
           //
           //
           //
      
           val1[i] = EMPTY_VALUE;
           val2[i] = EMPTY_VALUE;
           if (cross[i] != cross[i+1])
           if (cross[i] == 1)
                 val1[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
           else  val2[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
   }

   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (cross[whichBar] != cross[whichBar+1])
      if (cross[whichBar] == 1)
            doAlert("crossing up");
      else  doAlert("crossing down");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Dex_Adx ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Dex_Adx  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      

